import{S as ot,i as at,s as it,e as s,k as p,w as C,t as f,M as rt,c as o,d as t,m as u,a,x as U,h,b as l,G as n,g as r,y as I,L as lt,q as T,o as X,B as H,v as pt}from"../../chunks/vendor-hf-doc-builder.js";import{I as de}from"../../chunks/IconCopyLink-hf-doc-builder.js";import{C as st}from"../../chunks/CodeBlock-hf-doc-builder.js";function ft(Ue){let c,Z,d,b,L,P,ve,R,we,ee,k,ge,te,v,_,Y,D,be,G,_e,ne,q,K,$e,se,w,$,M,E,xe,B,ye,oe,m,Pe,W,De,Ee,J,Se,Oe,z,Ne,ke,ae,S,ie,j,qe,re,O,le,g,x,F,N,je,Q,Ae,pe,A,V,Ce,fe;return P=new de({}),D=new de({}),E=new de({}),S=new st({props:{code:`# make sure you're logged in with \`huggingface-cli login\`
from diffusers import OnnxStableDiffusionPipeline

pipe = OnnxStableDiffusionPipeline.from_pretrained(
    "runwayml/stable-diffusion-v1-5",
    revision="onnx",
    provider="CUDAExecutionProvider",
)

prompt = "a photo of an astronaut riding a horse on mars"
image = pipe(prompt).images[0]`,highlighted:`<span class="hljs-comment"># make sure you&#x27;re logged in with \`huggingface-cli login\`</span>
<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> OnnxStableDiffusionPipeline

pipe = OnnxStableDiffusionPipeline.from_pretrained(
    <span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>,
    revision=<span class="hljs-string">&quot;onnx&quot;</span>,
    provider=<span class="hljs-string">&quot;CUDAExecutionProvider&quot;</span>,
)

prompt = <span class="hljs-string">&quot;a photo of an astronaut riding a horse on mars&quot;</span>
image = pipe(prompt).images[<span class="hljs-number">0</span>]`}}),O=new st({props:{code:`from diffusers import OnnxStableDiffusionPipeline, OnnxStableDiffusionUpscalePipeline

prompt = "a photo of an astronaut riding a horse on mars"
steps = 50

txt2img = OnnxStableDiffusionPipeline.from_pretrained(
    "runwayml/stable-diffusion-v1-5",
    revision="onnx",
    provider="CUDAExecutionProvider",
)
small_image = txt2img(
    prompt,
    num_inference_steps=steps,
).images[0]

generator = torch.manual_seed(0)
upscale = OnnxStableDiffusionUpscalePipeline.from_pretrained(
    "ssube/stable-diffusion-x4-upscaler-onnx",
    provider="CUDAExecutionProvider",
)
large_image = upscale(
    prompt,
    small_image,
    generator=generator,
    num_inference_steps=steps,
).images[0]`,highlighted:`<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> OnnxStableDiffusionPipeline, OnnxStableDiffusionUpscalePipeline

prompt = <span class="hljs-string">&quot;a photo of an astronaut riding a horse on mars&quot;</span>
steps = <span class="hljs-number">50</span>

txt2img = OnnxStableDiffusionPipeline.from_pretrained(
    <span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>,
    revision=<span class="hljs-string">&quot;onnx&quot;</span>,
    provider=<span class="hljs-string">&quot;CUDAExecutionProvider&quot;</span>,
)
small_image = txt2img(
    prompt,
    num_inference_steps=steps,
).images[<span class="hljs-number">0</span>]

generator = torch.manual_seed(<span class="hljs-number">0</span>)
upscale = OnnxStableDiffusionUpscalePipeline.from_pretrained(
    <span class="hljs-string">&quot;ssube/stable-diffusion-x4-upscaler-onnx&quot;</span>,
    provider=<span class="hljs-string">&quot;CUDAExecutionProvider&quot;</span>,
)
large_image = upscale(
    prompt,
    small_image,
    generator=generator,
    num_inference_steps=steps,
).images[<span class="hljs-number">0</span>]`}}),N=new de({}),{c(){c=s("meta"),Z=p(),d=s("h1"),b=s("a"),L=s("span"),C(P.$$.fragment),ve=p(),R=s("span"),we=f("How to use the ONNX Runtime for inference"),ee=p(),k=s("p"),ge=f("\u{1F917} Diffusers provides a Stable Diffusion pipeline compatible with the ONNX Runtime. This allows you to run Stable Diffusion on any hardware that supports ONNX (including CPUs), and where an accelerated version of PyTorch is not available."),te=p(),v=s("h2"),_=s("a"),Y=s("span"),C(D.$$.fragment),be=p(),G=s("span"),_e=f("Installation"),ne=p(),q=s("ul"),K=s("li"),$e=f("TODO"),se=p(),w=s("h2"),$=s("a"),M=s("span"),C(E.$$.fragment),xe=p(),B=s("span"),ye=f("Stable Diffusion Inference"),oe=p(),m=s("p"),Pe=f("The snippet below demonstrates how to use the ONNX runtime. You need to use "),W=s("code"),De=f("OnnxStableDiffusionPipeline"),Ee=f(" instead of "),J=s("code"),Se=f("StableDiffusionPipeline"),Oe=f(". You also need to download the weights from the "),z=s("code"),Ne=f("onnx"),ke=f(" branch of the repository, and indicate the runtime provider you want to use."),ae=p(),C(S.$$.fragment),ie=p(),j=s("p"),qe=f("The snippet below demonstrates how to use the ONNX runtime with the Stable Diffusion upscaling pipeline."),re=p(),C(O.$$.fragment),le=p(),g=s("h2"),x=s("a"),F=s("span"),C(N.$$.fragment),je=p(),Q=s("span"),Ae=f("Known Issues"),pe=p(),A=s("ul"),V=s("li"),Ce=f("Generating multiple prompts in a batch seems to take too much memory. While we look into it, you may need to iterate instead of batching."),this.h()},l(e){const i=rt('[data-svelte="svelte-1phssyn"]',document.head);c=o(i,"META",{name:!0,content:!0}),i.forEach(t),Z=u(e),d=o(e,"H1",{class:!0});var ue=a(d);b=o(ue,"A",{id:!0,class:!0,href:!0});var Ie=a(b);L=o(Ie,"SPAN",{});var Te=a(L);U(P.$$.fragment,Te),Te.forEach(t),Ie.forEach(t),ve=u(ue),R=o(ue,"SPAN",{});var Xe=a(R);we=h(Xe,"How to use the ONNX Runtime for inference"),Xe.forEach(t),ue.forEach(t),ee=u(e),k=o(e,"P",{});var He=a(k);ge=h(He,"\u{1F917} Diffusers provides a Stable Diffusion pipeline compatible with the ONNX Runtime. This allows you to run Stable Diffusion on any hardware that supports ONNX (including CPUs), and where an accelerated version of PyTorch is not available."),He.forEach(t),te=u(e),v=o(e,"H2",{class:!0});var he=a(v);_=o(he,"A",{id:!0,class:!0,href:!0});var Le=a(_);Y=o(Le,"SPAN",{});var Re=a(Y);U(D.$$.fragment,Re),Re.forEach(t),Le.forEach(t),be=u(he),G=o(he,"SPAN",{});var Ye=a(G);_e=h(Ye,"Installation"),Ye.forEach(t),he.forEach(t),ne=u(e),q=o(e,"UL",{});var Ge=a(q);K=o(Ge,"LI",{});var Ke=a(K);$e=h(Ke,"TODO"),Ke.forEach(t),Ge.forEach(t),se=u(e),w=o(e,"H2",{class:!0});var me=a(w);$=o(me,"A",{id:!0,class:!0,href:!0});var Me=a($);M=o(Me,"SPAN",{});var Be=a(M);U(E.$$.fragment,Be),Be.forEach(t),Me.forEach(t),xe=u(me),B=o(me,"SPAN",{});var We=a(B);ye=h(We,"Stable Diffusion Inference"),We.forEach(t),me.forEach(t),oe=u(e),m=o(e,"P",{});var y=a(m);Pe=h(y,"The snippet below demonstrates how to use the ONNX runtime. You need to use "),W=o(y,"CODE",{});var Je=a(W);De=h(Je,"OnnxStableDiffusionPipeline"),Je.forEach(t),Ee=h(y," instead of "),J=o(y,"CODE",{});var ze=a(J);Se=h(ze,"StableDiffusionPipeline"),ze.forEach(t),Oe=h(y,". You also need to download the weights from the "),z=o(y,"CODE",{});var Fe=a(z);Ne=h(Fe,"onnx"),Fe.forEach(t),ke=h(y," branch of the repository, and indicate the runtime provider you want to use."),y.forEach(t),ae=u(e),U(S.$$.fragment,e),ie=u(e),j=o(e,"P",{});var Qe=a(j);qe=h(Qe,"The snippet below demonstrates how to use the ONNX runtime with the Stable Diffusion upscaling pipeline."),Qe.forEach(t),re=u(e),U(O.$$.fragment,e),le=u(e),g=o(e,"H2",{class:!0});var ce=a(g);x=o(ce,"A",{id:!0,class:!0,href:!0});var Ve=a(x);F=o(Ve,"SPAN",{});var Ze=a(F);U(N.$$.fragment,Ze),Ze.forEach(t),Ve.forEach(t),je=u(ce),Q=o(ce,"SPAN",{});var et=a(Q);Ae=h(et,"Known Issues"),et.forEach(t),ce.forEach(t),pe=u(e),A=o(e,"UL",{});var tt=a(A);V=o(tt,"LI",{});var nt=a(V);Ce=h(nt,"Generating multiple prompts in a batch seems to take too much memory. While we look into it, you may need to iterate instead of batching."),nt.forEach(t),tt.forEach(t),this.h()},h(){l(c,"name","hf:doc:metadata"),l(c,"content",JSON.stringify(ut)),l(b,"id","how-to-use-the-onnx-runtime-for-inference"),l(b,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(b,"href","#how-to-use-the-onnx-runtime-for-inference"),l(d,"class","relative group"),l(_,"id","installation"),l(_,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(_,"href","#installation"),l(v,"class","relative group"),l($,"id","stable-diffusion-inference"),l($,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l($,"href","#stable-diffusion-inference"),l(w,"class","relative group"),l(x,"id","known-issues"),l(x,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(x,"href","#known-issues"),l(g,"class","relative group")},m(e,i){n(document.head,c),r(e,Z,i),r(e,d,i),n(d,b),n(b,L),I(P,L,null),n(d,ve),n(d,R),n(R,we),r(e,ee,i),r(e,k,i),n(k,ge),r(e,te,i),r(e,v,i),n(v,_),n(_,Y),I(D,Y,null),n(v,be),n(v,G),n(G,_e),r(e,ne,i),r(e,q,i),n(q,K),n(K,$e),r(e,se,i),r(e,w,i),n(w,$),n($,M),I(E,M,null),n(w,xe),n(w,B),n(B,ye),r(e,oe,i),r(e,m,i),n(m,Pe),n(m,W),n(W,De),n(m,Ee),n(m,J),n(J,Se),n(m,Oe),n(m,z),n(z,Ne),n(m,ke),r(e,ae,i),I(S,e,i),r(e,ie,i),r(e,j,i),n(j,qe),r(e,re,i),I(O,e,i),r(e,le,i),r(e,g,i),n(g,x),n(x,F),I(N,F,null),n(g,je),n(g,Q),n(Q,Ae),r(e,pe,i),r(e,A,i),n(A,V),n(V,Ce),fe=!0},p:lt,i(e){fe||(T(P.$$.fragment,e),T(D.$$.fragment,e),T(E.$$.fragment,e),T(S.$$.fragment,e),T(O.$$.fragment,e),T(N.$$.fragment,e),fe=!0)},o(e){X(P.$$.fragment,e),X(D.$$.fragment,e),X(E.$$.fragment,e),X(S.$$.fragment,e),X(O.$$.fragment,e),X(N.$$.fragment,e),fe=!1},d(e){t(c),e&&t(Z),e&&t(d),H(P),e&&t(ee),e&&t(k),e&&t(te),e&&t(v),H(D),e&&t(ne),e&&t(q),e&&t(se),e&&t(w),H(E),e&&t(oe),e&&t(m),e&&t(ae),H(S,e),e&&t(ie),e&&t(j),e&&t(re),H(O,e),e&&t(le),e&&t(g),H(N),e&&t(pe),e&&t(A)}}}const ut={local:"how-to-use-the-onnx-runtime-for-inference",sections:[{local:"installation",title:"Installation"},{local:"stable-diffusion-inference",title:"Stable Diffusion Inference"},{local:"known-issues",title:"Known Issues"}],title:"How to use the ONNX Runtime for inference"};function ht(Ue){return pt(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class vt extends ot{constructor(c){super();at(this,c,ht,ft,it,{})}}export{vt as default,ut as metadata};
